using Exferia_Aplicacion.General;
using Exferia_CRM._1_Datos;
using Exferia_EntityFramework;
using Exferia_Formularios;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using System.Windows.Forms;

namespace Exferia_CRM._3_Vistas.Controladoras
{
    public class P_TrabajosRealizados_Historico_Controladora
    {
        #region Variables Generales
        private P_TrabajosRealizados_Historico g_frm_P_TrabajosRealizados_Historico = null; //Variable que enlaza con la pantalla asociada
        private PE_Esperando g_frm_PE_Esperando;//Pantalla de Espera para cuando se ejecutan tareas pesadas como cargar, grabar...
        
        //Clases de Negocio Necesarias para la carga de datos
        private CRMH_TrabajosRealizados_Datos g_obj_CRMH_TrabajosRealizados_Datos = new CRMH_TrabajosRealizados_Datos();

        public CRMH_TrabajosRealizados g_mdl_CRMH_TrabajosRealizados = null;//Modelo de los datos del trabajos realizado, cargados

        public bool g_bol_Termino_CargaDatos_Inicial = false;//Se utiliza para saber cuando se termina la carga de datos estaticos inciales

        public string g_str_GUID = "";
        public long g_lng_idEmpleado = -1;
        public long? g_lng_idTerminal = null;

        //Tareea Asincrona de carga de datos
        private BackgroundWorker g_obj_TareaAsincrona_CargarDatos;

        //Tareea Asincrona de grabar de datos
        private BackgroundWorker g_obj_TareaAsincrona_GrabarDatos;
        private bool g_bol_GrabarDatos_TerminoCorrectamente = true;
        private bool g_bol_GrabarDatos_VolverListado = true;

        //Tareea Asincrona de borrar de datos
        private BackgroundWorker g_obj_TareaAsincrona_BorrarDatos;
        private bool g_bol_BorrarDatos_VolverListado = true;
        #endregion

        public P_TrabajosRealizados_Historico_Controladora(P_TrabajosRealizados_Historico _frm_P_TrabajosRealizados_Historico)
        {
            g_frm_P_TrabajosRealizados_Historico = _frm_P_TrabajosRealizados_Historico;

            g_bol_Termino_CargaDatos_Inicial = true;
        }

        public void VaciarDatos()
        {
            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Id = -1;
            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Codigo = "";
            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Descripcion = "";
            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_FechaBorrado = null;

            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Id = -1;
            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Codigo = "";
            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Descripcion = "";
            g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_FechaBorrado = null;

            g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Horas.Text = "";
            g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Minutos.Text = "";
            g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_TrabajoRealizados.Text = "";
            g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Mascara_HoraInicio.Text = "";

            g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha.Exferia_FechaSeleccion_Fecha = "";

            string[] str_Separador = new string[] { " [" };
            //Si ya hay valores de objeto, los elimino para rellenarlos de nuevo
            if (g_frm_P_TrabajosRealizados_Historico.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None).Count() > 1)
            {
                g_frm_P_TrabajosRealizados_Historico.P_Base_TituloPantalla = (g_frm_P_TrabajosRealizados_Historico.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None))[0];
            }

            //Actualizar el Boton de Seleccion de pantalla ####################################################
            Variables.G_EMS_CONTROL_MENUSUPERIOR.Update_Texto_NombrePantalla(g_frm_P_TrabajosRealizados_Historico.Tag.ToString());
            //#################################################################################################

            g_mdl_CRMH_TrabajosRealizados = null;
        }

        public bool ComprobarCambios()
        {
            if (g_frm_P_TrabajosRealizados_Historico.P_Base_SeModificoDatosPantalla)
            {
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_GUARDARCAMBIOS()))
                {
                    GrabarDatos(false);

                    //Te quedas espernado a que termine la tarea asincrona de grabar
                    while (g_obj_TareaAsincrona_GrabarDatos.IsBusy)
                        Application.DoEvents();

                    return g_bol_GrabarDatos_TerminoCorrectamente;
                }
            }
            return true;
        }

        #region Cargar Datos
        public void RecargarDatos()
        {
            try
            {
                //Bloquear el formulario para que no se pueda hacer nada hasta que termine
                g_frm_P_TrabajosRealizados_Historico.Enabled = false;

                //Mostrar la pantalla de espera
                g_frm_PE_Esperando = new PE_Esperando();

                // Si la tarea asincrona esta en marcha la paro
                if (g_obj_TareaAsincrona_CargarDatos != null)
                {
                    while (g_obj_TareaAsincrona_CargarDatos.IsBusy)
                        Application.DoEvents();
                }
                else
                {
                    g_obj_TareaAsincrona_CargarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_CargarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_CargarDatos_DoWork);
                    g_obj_TareaAsincrona_CargarDatos.ProgressChanged += new ProgressChangedEventHandler(TareaAsincrona_CargarDatos_ProgressChanged);
                    g_obj_TareaAsincrona_CargarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_CargarDatos_Completed);
                    g_obj_TareaAsincrona_CargarDatos.WorkerReportsProgress = true;
                }

                //Vaciar
                VaciarDatos();

                //(Tarea Asincrona) Cargar Datos ##################################################################
                g_obj_TareaAsincrona_CargarDatos.RunWorkerAsync();
                //#################################################################################################

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_frm_P_TrabajosRealizados_Historico.Enabled = true;

                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                throw new Control_Errores(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA(), ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(RecargarDatos), true);
            }
        }
        private void TareaAsincrona_CargarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Cargar Valores
                if (CargarDatos(g_frm_P_TrabajosRealizados_Historico.P_Base_id) == false)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
                }
            }
            catch (ThreadAbortException ex)
            {
                Thread.ResetAbort();

                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_CargarDatos_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            try
            { }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_ProgressChanged));
            }
        }
        private void TareaAsincrona_CargarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }

            //Desbloquear el Formulario
            g_frm_P_TrabajosRealizados_Historico.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                        g_frm_P_TrabajosRealizados_Historico.Salir_P_Base();
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_CargarDatos_Completed));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());

                g_frm_P_TrabajosRealizados_Historico.Salir_P_Base();
            }
            finally
            {
                //Hacemos foco en el primer control
                g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Foco_Codigo();
            }
        }

        public bool CargarDatos(long _lng_id)
        {
            bool bol_ValorDevuelto = true;

            g_mdl_CRMH_TrabajosRealizados = g_obj_CRMH_TrabajosRealizados_Datos.Obtener(_lng_id);

            try
            {
                if (g_mdl_CRMH_TrabajosRealizados != null)
                {
                    //Paginador ................................................................................
                    if (g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen != null &&
                        g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                        g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                    {
                        long lng_id_ParaPaginacion = g_mdl_CRMH_TrabajosRealizados.id;
                        int int_PaginaDelObjeto = g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.IndexOf(g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Where(n => n.ID.Equals(lng_id_ParaPaginacion)).FirstOrDefault());

                        g_frm_P_TrabajosRealizados_Historico.g_obj_Funciones_Paginador.SetPaginaActual(int_PaginaDelObjeto);
                        // Asignando al paginador la pagina actual.
                        g_frm_P_TrabajosRealizados_Historico.Exferia_Paginador_TrabajosRealizados_Historico.PaginaActual = g_frm_P_TrabajosRealizados_Historico.g_obj_Funciones_Paginador.GetPaginaActual();
                    }
                    //...........................................................................................

                    //TextBox

                    if((g_mdl_CRMH_TrabajosRealizados.duracionSegundos / 60) > 59)
                    {
                        long? horas = g_mdl_CRMH_TrabajosRealizados.duracionSegundos / 3600;
                        long? resto = g_mdl_CRMH_TrabajosRealizados.duracionSegundos % 3600;

                        if (resto > 59)
                        {
                            long? minutos = resto / 60;
                            if(minutos != null)
                            { g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Minutos.Text = minutos.Value.ToString().Length > 1 ? minutos.Value.ToString() : "0" + minutos.Value; }
                        }

                        if(horas != null)
                        { g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Horas.Text = horas.Value.ToString().Length > 1 ? horas.Value.ToString() : "0" + horas.Value.ToString(); }
                    }
                    else
                    {
                        long? minutos = g_mdl_CRMH_TrabajosRealizados.duracionSegundos / 60;

                        if(minutos != null)
                        { g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Minutos.Text = minutos.Value.ToString().Length > 1 ? minutos.Value.ToString() : "0"+ minutos.Value.ToString(); }
                        
                        g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Horas.Text = "00";
                    }
                    
                    g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_TrabajoRealizados.Text = g_mdl_CRMH_TrabajosRealizados.trabajoRealizado;
                    g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Mascara_HoraInicio.Text = g_mdl_CRMH_TrabajosRealizados.fechaHora.ToString("HH:mm");

                    g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha.Exferia_FechaSeleccion_Fecha = g_mdl_CRMH_TrabajosRealizados.fechaHora.ToString("dd/MM/yyyy");

                    //Exferia_F3_Empleado no podrá ser nulo
                    g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Id = g_mdl_CRMH_TrabajosRealizados.CRM_ClientesPotenciales.id;
                    g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Codigo = g_mdl_CRMH_TrabajosRealizados.CRM_ClientesPotenciales.codigo;
                    g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Descripcion = g_mdl_CRMH_TrabajosRealizados.CRM_ClientesPotenciales.razonSocial;
                    g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_FechaBorrado = g_mdl_CRMH_TrabajosRealizados.CRM_ClientesPotenciales.fechaBorrado;

                    if (g_mdl_CRMH_TrabajosRealizados.CRM_MotivosNoVisita != null)
                    {
                        g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Id = g_mdl_CRMH_TrabajosRealizados.CRM_MotivosNoVisita.id;
                        g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Codigo = g_mdl_CRMH_TrabajosRealizados.CRM_MotivosNoVisita.codigo;
                        g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Descripcion = g_mdl_CRMH_TrabajosRealizados.CRM_MotivosNoVisita.descripcion;
                        g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_FechaBorrado = g_mdl_CRMH_TrabajosRealizados.CRM_MotivosNoVisita.fechaBorrado;
                    }

                    //Mostrar Campo en el Titulo de mantenimiento
                    string str_MenuSuperior_Codigo = "";
                    if (g_frm_P_TrabajosRealizados_Historico.g_mdl_PRV_OpcionesDetalle != null &&
                       g_frm_P_TrabajosRealizados_Historico.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento != null &&
                       g_frm_P_TrabajosRealizados_Historico.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento.Trim().Length > 0)
                    {
                        //Obtener el Array de campos
                        string[] arr_Campos = g_frm_P_TrabajosRealizados_Historico.g_mdl_PRV_OpcionesDetalle.camposMostrar_TituloMantenimiento.Split(new Char[] { ',' });
                        string str_ValorAMostrarFinal = "";

                        string[] str_Separador = new string[] { " [" };
                        //Si ya hay valores de objeto, los elimino para rellenarlos de nuevo
                        if (g_frm_P_TrabajosRealizados_Historico.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None).Count() > 1)
                        {
                            g_frm_P_TrabajosRealizados_Historico.P_Base_TituloPantalla = (g_frm_P_TrabajosRealizados_Historico.P_Base_TituloPantalla.Split(str_Separador, StringSplitOptions.None))[0];
                        }

                        dynamic dnm_Objeto = g_mdl_CRMH_TrabajosRealizados;
                        foreach (string str_campo in arr_Campos)
                        {
                            var Valor = dnm_Objeto.GetType().GetProperty(str_campo).GetValue(dnm_Objeto, null);
                            if (Valor != null)
                            {
                                str_ValorAMostrarFinal += " " + Valor;
                            }

                            //Codigo
                            if (str_campo.Equals(nameof(g_mdl_CRMH_TrabajosRealizados.fechaHora)))
                            {
                                str_MenuSuperior_Codigo = g_mdl_CRMH_TrabajosRealizados.fechaHora.ToString("dd/MM/yyyy");
                            }
                        }
                        if (str_ValorAMostrarFinal != "")
                        {
                            g_frm_P_TrabajosRealizados_Historico.P_Base_TituloPantalla += " [" + str_ValorAMostrarFinal + "] - Modificar";
                        }
                    }

                    //Actualizar el Boton de Seleccion de pantalla ####################################################
                    Variables.G_EMS_CONTROL_MENUSUPERIOR.Add_Texto_NombrePantalla_Descripciones(g_frm_P_TrabajosRealizados_Historico.Tag.ToString(), str_MenuSuperior_Codigo);
                    //#################################################################################################

                    g_frm_P_TrabajosRealizados_Historico.P_Base_SeModificoDatosPantalla = false;

                }
            }
            catch (Control_Errores)
            {
                bol_ValorDevuelto = false;
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(CargarDatos));
            }

            return bol_ValorDevuelto;
        }
        #endregion

        #region Grabar Datos
        public void GrabarDatos(bool _bol_VolverAlListado)
        {
            try
            {
                g_bol_GrabarDatos_VolverListado = _bol_VolverAlListado;

                g_bol_GrabarDatos_TerminoCorrectamente = true;

                g_frm_P_TrabajosRealizados_Historico.Enabled = false;
                g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_GRABANDODATOS());

                g_obj_TareaAsincrona_GrabarDatos = new BackgroundWorker();
                g_obj_TareaAsincrona_GrabarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_GrabarDatos_DoWork);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_GrabarDatos_Completed);
                g_obj_TareaAsincrona_GrabarDatos.RunWorkerAsync();

                g_frm_PE_Esperando.ShowDialog();
            }
            catch (Exception ex)
            {
                g_bol_GrabarDatos_TerminoCorrectamente = false;
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }
                g_frm_P_TrabajosRealizados_Historico.Enabled = true;

                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(GrabarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA());
            }
        }
        private void TareaAsincrona_GrabarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                //Validar Primero
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_VALIDACION = ValidarDatos();
                if (mdl_ValorDevuelto_Modelo_VALIDACION.TodoCorrecto)
                {
                    mdl_ValorDevuelto_Modelo = GrabarDatos_Final();
                }
                else
                {
                    mdl_ValorDevuelto_Modelo = mdl_ValorDevuelto_Modelo_VALIDACION;
                }
            }
            catch (ThreadAbortException ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();

            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();

            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();

            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_GrabarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            //Quitar Pantalla de Espera
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            //Desbloquear Formulario
            g_frm_P_TrabajosRealizados_Historico.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);

                        //Poner el Foco en el objeto que tuvoel problema en validar
                        if (mdl_ValorDevuelto_Modelo_Resultado.Objeto != null)
                        {
                            Funciones.Poner_Foco_Objeto(g_frm_P_TrabajosRealizados_Historico, mdl_ValorDevuelto_Modelo_Resultado.Objeto);
                        }
                    }

                    g_bol_GrabarDatos_TerminoCorrectamente = false;
                }
                else
                {
                    if (g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen != null)
                    {
                        //Devolver al Listado el Row Añadidod/Modificado
                        List<object> lst_obj = new List<object>();
                        lst_obj.Add(g_frm_P_TrabajosRealizados_Historico.g_mdl_PRV_OpcionesDetalle.opcion);
                        lst_obj.Add(mdl_ValorDevuelto_Modelo_Resultado.Id);

                        g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen.P_Base_ActualizarRegistro_ConObjeto(lst_obj, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);

                        g_frm_P_TrabajosRealizados_Historico.P_Base_SeModificoDatosPantalla = false;
                    }

                    g_frm_P_TrabajosRealizados_Historico.Close();
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_GrabarDatos_Completed));
            }
        }
        public INTERNO_ValorDevuelto_Modelo ValidarDatos()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                //La fecha de alta no puede estar vacia y debe ser correcta
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                {
                    int int_fechaAlta_Respuesta = Funciones.Fecha_Validacion(g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha.Exferia_FechaSeleccion_Fecha.Trim(' ', '/'));

                    if (int_fechaAlta_Respuesta == 1) //Vacia
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha.Exferia_FechaSeleccion_Descripcion);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha;
                    }
                    else if (int_fechaAlta_Respuesta == 2) //Incorrecta
                    {
                        mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                        mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_FECHA_INCORRECTA(g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha.Exferia_FechaSeleccion_Descripcion);
                        mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha;
                    }
                }

                //La Hora no puede estar vacia
                if ((mdl_ValorDevuelto_Modelo.TodoCorrecto) && (g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Mascara_HoraInicio.Text.Trim().Length == 0))
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_TrabajosRealizados_Historico.Exferia_Label_HoraInicio.Text);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Mascara_HoraInicio;
                }

                //El ClientePotencial no puede estar vacio (obligatorio)
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Codigo.Trim().Length == 0)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }

                //Si hay ClientePotencial Validar que es correcto{
                if (mdl_ValorDevuelto_Modelo.TodoCorrecto && (g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Codigo.Trim().Length != 0 ||
                    g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Descripcion.Trim().Length != 0) && g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Id == -1)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_GENERAL_VALIDACIONES_VACIO(g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Titulo);
                    mdl_ValorDevuelto_Modelo.Objeto = g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_PRINCIPAL_TextBox_Codigo;
                }
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(ValidarDatos));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_VALIDARDATOSPANTALLA();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        private INTERNO_ValorDevuelto_Modelo GrabarDatos_Final()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();

            //Iniciar transaccion
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    CRMH_TrabajosRealizados mdl_CRMH_TrabajosRealizados = new CRMH_TrabajosRealizados();
                    mdl_CRMH_TrabajosRealizados.id = g_mdl_CRMH_TrabajosRealizados != null ? g_mdl_CRMH_TrabajosRealizados.id : -1;
                    mdl_CRMH_TrabajosRealizados.id_TrabajoRealizado_CRMS = g_mdl_CRMH_TrabajosRealizados != null ? g_mdl_CRMH_TrabajosRealizados.id_TrabajoRealizado_CRMS : null;

                    //Exferia_TexBox
                    mdl_CRMH_TrabajosRealizados.trabajoRealizado = g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_TrabajoRealizados.Text;

                    DateTime dtt_fechaHora_Inicio = DateTime.ParseExact(g_frm_P_TrabajosRealizados_Historico.Exferia_FechaSeleccion_Fecha.Exferia_FechaSeleccion_Fecha, "dd/MM/yyyy", CultureInfo.InvariantCulture);
                    TimeSpan tms_hora_Inicio = TimeSpan.Parse(g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Mascara_HoraInicio.Text);
                    dtt_fechaHora_Inicio = new DateTime(dtt_fechaHora_Inicio.Year, dtt_fechaHora_Inicio.Month, dtt_fechaHora_Inicio.Day, tms_hora_Inicio.Hours, tms_hora_Inicio.Minutes, 0);

                    mdl_CRMH_TrabajosRealizados.fechaHora = dtt_fechaHora_Inicio;

                    long lng_duracionSegundos = (g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Minutos.Text.Trim().Length > 0 ? long.Parse(g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Minutos.Text) : 0) * 60;
                    lng_duracionSegundos = lng_duracionSegundos + (g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Horas.Text.Trim().Length> 0 ? long.Parse(g_frm_P_TrabajosRealizados_Historico.Exferia_TextBox_Horas.Text) : 0) * 3600;
                    mdl_CRMH_TrabajosRealizados.duracionSegundos = lng_duracionSegundos;

                    //Exferia_F3
                    mdl_CRMH_TrabajosRealizados.idEmpleado = g_lng_idEmpleado;
                    mdl_CRMH_TrabajosRealizados.idClientePotencial = g_frm_P_TrabajosRealizados_Historico.Exferia_F3_ClientesPotenciales.Exferia_F3_Id;
                    if (!g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Id.Equals(-1))
                    {
                        mdl_CRMH_TrabajosRealizados.idMotivoNoVisita = g_frm_P_TrabajosRealizados_Historico.Exferia_F3_MotivosNoVisita.Exferia_F3_Id;
                    }

                    //Terminal
                    mdl_CRMH_TrabajosRealizados.idTerminal = g_lng_idTerminal;
                    
                    //Finalmente Asignamos el GUID de la liquidacion al trabajo realizado
                    mdl_CRMH_TrabajosRealizados.guid = g_str_GUID;

                    //Grabamos el modelo ya relleno
                    mdl_ValorDevuelto_Modelo = g_obj_CRMH_TrabajosRealizados_Datos.Grabar(mdl_CRMH_TrabajosRealizados);

                    if (mdl_ValorDevuelto_Modelo.TodoCorrecto)
                    {
                        transaccion_SQL.Complete();
                    }

                    transaccion_SQL.Dispose();
                }
                catch (Control_Errores)
                {
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
                    transaccion_SQL.Dispose();
                }
                catch (Exception ex)
                {
                    Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(GrabarDatos_Final));
                    mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                    mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_GRABARDATOSPANTALLA();
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar Datos
        public void BorrarDatos(bool _bol_VolverAlListado)
        {
            try
            {
                // Preguntar si esta Seguro de Borrar
                if (Mensajes.MostrarMensaje_Pregunta(Mensajes.G_STR_MENSAJES_GENERAL_PREGUNTA_BORRAR()))
                {
                    g_bol_BorrarDatos_VolverListado = _bol_VolverAlListado;
                    g_frm_P_TrabajosRealizados_Historico.Enabled = false;
                    g_frm_PE_Esperando = new PE_Esperando(Mensajes.G_STR_ESPERANDO_BORRANDODATOS());

                    g_obj_TareaAsincrona_BorrarDatos = new BackgroundWorker();
                    g_obj_TareaAsincrona_BorrarDatos.DoWork += new DoWorkEventHandler(TareaAsincrona_BorrarDatos_DoWork);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerCompleted += new RunWorkerCompletedEventHandler(TareaAsincrona_BorrarDatos_Completed);
                    g_obj_TareaAsincrona_BorrarDatos.RunWorkerAsync();

                    g_frm_PE_Esperando.ShowDialog();
                }
            }
            catch (Exception ex)
            {
                if (g_frm_PE_Esperando != null)
                {
                    g_frm_PE_Esperando.Close();
                    g_frm_PE_Esperando = null;
                }

                g_frm_P_TrabajosRealizados_Historico.Enabled = true;

                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(BorrarDatos));
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA());
            }
        }
        private void TareaAsincrona_BorrarDatos_DoWork(object sender, DoWorkEventArgs e)
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                // Borrar 
                mdl_ValorDevuelto_Modelo = BorrarDatos_Final();
            }
            catch (ThreadAbortException ex)
            {
                Thread.ResetAbort();

                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(TareaAsincrona_BorrarDatos_DoWork));

                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            finally
            {
                e.Result = mdl_ValorDevuelto_Modelo;
            }
        }
        private void TareaAsincrona_BorrarDatos_Completed(object sender, RunWorkerCompletedEventArgs e)
        {
            //Quitar Pantalla de Espera
            if (g_frm_PE_Esperando != null)
            {
                g_frm_PE_Esperando.Close();
                g_frm_PE_Esperando = null;
            }
            //Desbloquear Formulario
            g_frm_P_TrabajosRealizados_Historico.Enabled = true;

            try
            {
                INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo_Resultado = (INTERNO_ValorDevuelto_Modelo)e.Result;

                //Mostrar si tuviera algun mensaje
                if (mdl_ValorDevuelto_Modelo_Resultado.TodoCorrecto == false)
                {
                    if (mdl_ValorDevuelto_Modelo_Resultado.Mensaje.Trim().Length > 0)
                    {
                        Mensajes.MostrarMensaje(mdl_ValorDevuelto_Modelo_Resultado.Mensaje);
                    }
                }
                else
                {
                    if(g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen != null)
                    {
                        List<object> lst_obj = new List<object>();
                        mdl_ValorDevuelto_Modelo_Resultado.Listado_Id = new List<long>();
                        mdl_ValorDevuelto_Modelo_Resultado.Listado_Id.Add(mdl_ValorDevuelto_Modelo_Resultado.Id);
                        lst_obj.Add(g_frm_P_TrabajosRealizados_Historico.g_mdl_PRV_OpcionesDetalle.opcion);
                        lst_obj.Add(mdl_ValorDevuelto_Modelo_Resultado.Listado_Id);

                        g_frm_P_TrabajosRealizados_Historico.P_Base_PantallaOrigen.P_Base_ActualizarRegistro_ConObjeto(lst_obj, mdl_ValorDevuelto_Modelo_Resultado.TipoAccion);
                    }

                    g_frm_P_TrabajosRealizados_Historico.Close();
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(BorrarDatos_Final));
            }
        }
        private INTERNO_ValorDevuelto_Modelo BorrarDatos_Final()
        {
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();

            try
            {
                mdl_ValorDevuelto_Modelo = g_obj_CRMH_TrabajosRealizados_Datos.Borrar(g_mdl_CRMH_TrabajosRealizados != null ? g_mdl_CRMH_TrabajosRealizados.id : -1);

                return mdl_ValorDevuelto_Modelo;
            }
            catch (Control_Errores)
            {
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_TrabajosRealizados_Historico_Controladora) + "/" + nameof(BorrarDatos_Final));
                mdl_ValorDevuelto_Modelo.TodoCorrecto = false;
                mdl_ValorDevuelto_Modelo.Mensaje = Mensajes.G_STR_MENSAJES_GENERAL_ERROR_BORRARDATOSPANTALLA();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
